package info.bukova.isspst;

import info.bukova.isspst.data.Permission;
import info.bukova.isspst.data.Role;
import info.bukova.isspst.reporting.Report;
import info.bukova.isspst.reporting.ReportMapping;
import info.bukova.isspst.services.addressbook.AdbService;
import info.bukova.isspst.services.buildings.BuildingService;
import info.bukova.isspst.services.users.RoleService;
import info.bukova.isspst.services.users.UserService;

public class Constants {
	
	public final static String DEF_ADMIN = "admin";
	public final static String DEF_ADMIN_PASSWD = "admin";
	public final static String ROLE_USER = "ROLE_USER";
	public final static String ROLE_ADMIN = "ROLE_ADMIN";
	public final static String ROLE_DIRECTOR = "ROLE_DIRECTOR";
	public final static String ROLE_MANAGER = "ROLE_MANAGER";
	public final static String ROLE_PRINCIPAL = "ROLE_PRINCIPAL";
	public final static String ROLE_ACCOUNTANT = "ROLE_ACCOUNTANT";
	public final static String ROLE_SUPPLIER = "ROLE_SUPPLIER";
	public final static String ROLE_TECHNICIAN = "ROLE_TECHNICIAN";
	public final static String ROLE_LEADER = "ROLE_LEADER";
	public final static Role ROLES[] = {
		new Role(ROLE_ADMIN, "Administrátor"),
		new Role(ROLE_DIRECTOR, "Ředitel"),
		new Role(ROLE_MANAGER, "Správce"),
		new Role(ROLE_PRINCIPAL, "Příkazce"),
		new Role(ROLE_ACCOUNTANT, "Účetní"),
		new Role(ROLE_SUPPLIER, "Zásobovač"),
		new Role(ROLE_TECHNICIAN, "Technik"),
		new Role(ROLE_LEADER, "Vedoucí"),
		new Role(ROLE_USER, "Uživatel")
	};
	
	public final static String PERM_READ = "PERM_READ";
	public final static String PERM_ADD = "PERM_ADD";
	public final static String PERM_EDIT = "PERM_EDIT";
	public final static String PERM_DELETE = "PERM_DELETE";
	public final static Permission DEF_PERMISSIONS[] = {
		new Permission(PERM_READ, "Číst"),
		new Permission(PERM_ADD, "Přidávat"),
		new Permission(PERM_EDIT, "Upravit"),
		new Permission(PERM_DELETE, "Mazat")
	};
	
	public final static String MOD_USERS = "USERS";
	public final static String MOD_PERMISSIONS = "PERMISSIONS";
	public final static String MOD_ADDRESSBOOK = "ADDRESSBOOK";
	public final static String MOD_BUILDINGS = "BUILDINGS";
	public final static Module MODULES[] = {
		new Module(MOD_USERS, "Uživatelé", UserService.class),
		new Module(MOD_PERMISSIONS, "Práva", RoleService.class),
		new Module(MOD_ADDRESSBOOK, "Dodavatelé", AdbService.class),
		new Module(MOD_BUILDINGS, "Budovy", BuildingService.class)
	};
	
	public final static String DYNAMIC_REPORT_NAME = "Tabulková sestava";
	public final static ReportMapping REPORTS[] = {
		new ReportMapping(MOD_ADDRESSBOOK, new Report("Adresní karty", "address"))
	};
}
