package info.bukova.isspst.reporting;

import java.io.File;

import javax.servlet.ServletContext;

import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.JasperRunManager;
import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;
import net.sf.jasperreports.engine.util.JRLoader;
import net.sf.jasperreports.engine.util.JRProperties;

@SuppressWarnings("deprecation")
public class PredefinedGenerator implements Generator {
	
	private ReportDefinition definition;
	private ServletContext ctx;
	
	public PredefinedGenerator(ReportDefinition definition, ServletContext ctx) {
		this.definition = definition;
		this.ctx = ctx;
	}

	@Override
	public byte[] generate() {
		byte[] bytes = null;
		
		try {
			JasperReport report = (JasperReport) JRLoader.loadObject(getReportFile());
			JRProperties.setProperty("net.sf.jasperreports.default.pdf.encoding", "Cp1250");
			bytes = JasperRunManager.runReportToPdf(report, definition.getParams(), new JRBeanCollectionDataSource(definition.getDataSet()));;
		} catch (JRException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return bytes;
	}
	
	protected File getReportFile() {
		return new File(ctx.getRealPath("WEB-INF/reports") + "/" + definition.getReport().getJasperFile() + ".jasper");
	}

}
