package info.bukova.isspst.reporting;

import java.io.IOException;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

@Controller
public class ReportController {
	
	@Autowired
	private ReportDefinition reportDefinition;
	@Autowired
	private GeneratorFactory factory;
	
	@RequestMapping("report.pdf")
	public void pdfReport(HttpServletResponse response) {
		Generator gen = factory.createGenerator(reportDefinition);
		byte[] data = gen.generate();
		String contentType = "application/pdf";
		
		ServletOutputStream os = null;
		
		try {
			os = response.getOutputStream();
		} catch (IOException e1) {
			e1.printStackTrace();
			return;
		}
		
//		if (reportDefinition.getReport() == null || reportDefinition.getDataSet() == null) {
//			writeError(os, "Definition is null");
//			return;
//		}
		
		response.setContentType(contentType);
		response.setContentLength(data.length);
				
		try {
			os.write(data, 0, data.length);
			os.flush();
			os.close();
		} catch (IOException e) {
			e.printStackTrace();
//		} catch (ReportException e) {
//			writeError(os, e);
		} finally {
			if (os != null) {
				try {
					os.flush();
					os.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}

}
