package info.bukova.isspst.sort;

import java.lang.reflect.Method;

public class ReflectionTools {

	private static String capitalizeFirstLetter(String string)
	{
		String result = string.substring(0,1).toUpperCase() + string.substring(1, string.length());
		return result;
	}
	
	public static String getGetterName(String propertyName)
	{
		String getterName = "get" + ReflectionTools.capitalizeFirstLetter(propertyName);
		return getterName;
	}
	
	public static String getBoolGetterName(String propertyName)
	{
		String getterName = "is" + ReflectionTools.capitalizeFirstLetter(propertyName);
		return getterName;
	}
	
	public static Method getGetterMethod(Object bean, String propertyName)
	{
		Class<?> beanClass = bean.getClass();
		
		try
		{
			return beanClass.getMethod(ReflectionTools.getGetterName(propertyName));
		}
		catch(Throwable t)
		{
			// ignore
		}
		
		try
		{
			return beanClass.getMethod(ReflectionTools.getBoolGetterName(propertyName));
		}
		catch(Throwable t)
		{
			// ignore
		}
		
		throw new IllegalArgumentException("Not getter method found for '" + propertyName + "', bean: " + bean);
	}
}
