package info.bukova.isspst.ui.reporting;

import java.beans.BeanInfo;
import java.beans.IntrospectionException;
import java.beans.Introspector;
import java.beans.PropertyDescriptor;
import java.util.ArrayList;
import java.util.List;

import info.bukova.isspst.reporting.Report;
import info.bukova.isspst.reporting.ReportDefinition;
import info.bukova.isspst.reporting.ReportType;
import info.bukova.isspst.ui.ListChecks;
import info.bukova.isspst.ui.LocaleConverter;

import org.zkoss.bind.annotation.Init;
import org.zkoss.zk.ui.select.annotation.WireVariable;

public class ColSelectVM {
	
	@WireVariable
	private ReportDefinition reportDefinition;
	private LocaleConverter locConverter;
	
	@Init
	public void init() {
		locConverter = new LocaleConverter();
	}
	
	public ListChecks<String> getColumns() {
		Report selected = reportDefinition.getReport();
		List<Object> data = reportDefinition.getDataSet();
		
		if (selected == null || selected.getType() != ReportType.DYNAMIC) {
			return null;
		}
		if (data == null || data.size() == 0) {
			return null;
		}
		
		BeanInfo beanInfo;
		try {
			beanInfo = Introspector.getBeanInfo(data.get(0).getClass());
		} catch (IntrospectionException e) {
			return null;
		}
	    PropertyDescriptor[] pds = beanInfo.getPropertyDescriptors();
	    List<String> properties = new ArrayList<String>();
	    for (PropertyDescriptor pd : pds) {
	    	if (!(pd.getName().equals("password") || pd.getName().equals("class") || pd.getName().equals("id") || pd.getName().equals("valid"))) {
	    		properties.add(pd.getName());
	    	}
	    }
		ListChecks<String> columns = new ListChecks<String>(reportDefinition.getFieldsToPrint(), properties);
		
		return columns;
	}

	public LocaleConverter getLocConverter() {
		return locConverter;
	}

	public ReportDefinition getReportDefinition() {
		return reportDefinition;
	}

}
