package info.bukova.isspst.ui.users;

import info.bukova.isspst.Constants;
import info.bukova.isspst.Module;
import info.bukova.isspst.data.Role;
import info.bukova.isspst.services.users.PermissionService;
import info.bukova.isspst.ui.FormViewModel;

import java.util.Arrays;
import java.util.List;

import org.zkoss.bind.annotation.Init;
import org.zkoss.zk.ui.select.annotation.WireVariable;

public class PermissionForm extends FormViewModel<Role> {
	
	@WireVariable
	private PermissionService permissionService;
	private RolePermissions rolePerms;
	
	@Init(superclass = true)
	public void init() {
		rolePerms = new RolePermissions(getDataBean(), permissionService.getAll());
	}
	
	public List<Module> getModules() {
		return Arrays.asList(Constants.MODULES);
	}
	
	public RolePermissions getRolePerms() {
		return rolePerms;
	}

}
